<!DOCTYPE html>
<html lang="en">
  <head>
    <title>36h - Controller</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta http-equiv="X-UA-Compatible" content="ie=edge" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.4.1/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/stats.js/r16/Stats.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/dat-gui/0.7.6/dat.gui.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/socket.io/2.3.0/socket.io.js"></script>

    <link type="text/css" rel="stylesheet" href="main.css" />

    <script>
      var socket = io();

      var GuiTest = function() {
        this.waveSpeed = 50;
        this.waveLength = 100;
        this.waveHeight = 50;
      };

      $(document).ready(function(radius, camera) {
        var gui_param = new GuiTest();

        var gui = new dat.gui.GUI();

        var guiCameraFolder = gui.addFolder("Camera");
        var guiWaveFolder = gui.addFolder("Wave");
        guiWaveFolder.open();

        guiCameraFolder
          .add(camera, "fov", radius * 4, radius * 20)
          .step(0.1)
          .onChange(function() {
            camera.updateProjectionMatrix();
          });
        guiCameraFolder.add("camera.position", "y", -200, 200).step(1);
        guiCameraFolder.add("camera.position", "z", -200, 200).step(1);

        guiWaveFolder
          .add(params, "waveSpeed", 0, 0.1)
          .step(0.00001)
          .listen()
          .onChange(function(value) {
            socket.emit("waveSpeed", data);
            // params.waveSpeed = value;
          });
        guiWaveFolder
          .add(params, "waveLength", 0, 0.1)
          .step(0.00001)
          .listen()
          .onChange(function(value) {
            socket.emit("waveLength", data);
            // params.waveLength = value;
          });
        guiWaveFolder
          .add(params, "waveHeight", 0, 3)
          .step(0.01)
          .listen()
          .onChange(function(value) {
            socket.emit("waveHeight", data);
            // params.waveHeight = value;
          });

        // var waveSpeed_controller = gui.add(gui_param, "waveSpeed", 0, 100);
        // var waveLength_controller = gui.add(gui_param, "waveLength", 0, 200);
        // var waveHeight_controller = gui.add(gui_param, "waveHeight", 0, 100);

        // waveSpeed_controller.onChange(function(data) {
        //   socket.emit("waveSpeed", data);
        // });

        // waveLength_controller.onChange(function(data) {
        //   socket.emit("waveLength", data);
        // });

        // waveHeight_controller.onChange(function(data) {
        //   socket.emit("waveHeight", data);
        // });
      });
    </script>
  </head>
  <body></body>
</html>
